]> git.pld-linux.org Git - packages/rpm-build-tools.git/blobdiff - builder.sh
- check for upper-case alpha|beta|pre|rc too
[packages/rpm-build-tools.git] / builder.sh
index d5eb49d4404c3bcdd3a38d55b4e171934bfffb17..0c5d02e050a04f72ba1aca4e883baafdbfe1fed4 100644 (file)
@@ -3,11 +3,12 @@
 # $Id$
 # Exit codes:
 #      0 - succesful
-#      1 - help dispayed
+#      1 - help displayed
 #      2 - no spec file name in cmdl parameters
 #      3 - spec file not stored in repo
 #      4 - some source, patch or icon files not stored in repo
 #      5 - package build failed
+#      6 - spec file with errors
 
 # Notes (todo):
 #      - builder -u fetches current version first
@@ -16,6 +17,7 @@
 #      - doesn't get sources for specs with %include /usr/lib/rpm/macros.python
 #        when there's no rpm-pythonprov (rpm's fault, but it's ugly anyway)
 #      - as above with %include /usr/lib/rpm/macros.perl and no rpm-perlprov
+#      - when Icon: field is present, -5 and -a5 doesn't work
 
 VERSION="\
 Build package utility from PLD CVS repository
@@ -50,7 +52,6 @@ LOGDIR=""
 LOGDIROK=""
 LOGDIRFAIL=""
 LASTLOG_FILE=""
-LTAG=""
 CHMOD="no"
 CHMOD_MODE="0444"
 RPMOPTS=""
@@ -76,8 +77,11 @@ DEF_NICE_LEVEL=0
 
 FAIL_IF_NO_SOURCES="yes"
 
-GETURI="wget --passive-ftp -c -nd -t$WGET_RETRIES --inet"
-GETURI2="wget -c -nd -t$WGET_RETRIES --inet"
+wget --help 2>&1 | grep -q ' \-\-inet ' && WGET_OPTS="$WGET_OPTS --inet"
+wget --help 2>&1 | grep -q ' \-\-retry\-connrefused ' && WGET_OPTS="$WGET_OPTS --retry-connrefused"
+
+GETURI="wget --passive-ftp -c -nd -t$WGET_RETRIES $WGET_OPTS"
+GETURI2="wget -c -nd -t$WGET_RETRIES $WGET_OPTS"
 GETLOCAL="cp -a"
 
 if (rpm --version 2>&1 | grep -q '4.0.[0-2]'); then
@@ -108,13 +112,14 @@ Usage: builder [-D|--debug] [-V|--version] [-a|--as_anon] [-b|-ba|--build]
        [-h|--help] [--http] [{-l,--logtofile} <logfile>] [-m|--mr-proper]
        [-q|--quiet] [--date <yyyy-mm-dd> [-r <cvstag>] [{-T--tag <cvstag>]
        [-Tvs|--tag-version-stable] [-Tvn|--tag-version-nest]
-       [-Ts|--tag-stable] [-Tn|--tag-nest] [-Tv|--tag-version]
+       [-Ts|--tag-stable] [-Tn|--tag-nest] [-Tv|--tag-version] 
+       [{-Tp|--tag-prefix} <prefix>]
        [-nu|--no-urls] [-v|--verbose] [--opts <rpm opts>]
        [--with/--without <feature>] [--define <macro> <value>] <package>[.spec]
 
        -5, --update-md5
-                       - update md5 comments in spec, implies -nd
-       -a5, --add-md5  - add md5 comments to URL sources, implies -nc -nd
+                       - update md5 comments in spec, implies -nd -ncs
+       -a5, --add-md5  - add md5 comments to URL sources, implies -nc -nd -ncs
        -D, --debug     - enable script debugging mode,
        -V, --version   - output builder version
        -a, --as_anon   - get files via pserver as cvs@$CVS_SERVER,
@@ -134,6 +139,7 @@ Usage: builder [-D|--debug] [-V|--version] [-a|--as_anon] [-b|-ba|--build]
                        - setup \$CVSROOT,
        --define <macro> <value>
                        - define a macro <macro> with value <value>,
+       --nodeps        - rpm won't check any dependences
        -g, --get       - get <package>.spec and all related files from
                          CVS repo or HTTP/FTP,
        -h, --help      - this message,
@@ -174,6 +180,8 @@ Usage: builder [-D|--debug] [-V|--version] [-a|--as_anon] [-b|-ba|--build]
                        - add cvs tag NEST for files,
        -Tv, --tag-version
                        - add cvs tag NAME-VERSION-RELESE for files,
+       -Tp, --tag-prefix <prefix>
+                       - add <prefix> to NAME-VERSION-RELEASE tags,
        -v, --verbose   - be verbose,
        -u, --try-upgrade
                        - check version, and try to upgrade package
@@ -189,534 +197,36 @@ Usage: builder [-D|--debug] [-V|--version] [-a|--as_anon] [-b|-ba|--build]
 "
 }
 
-rpm_dump () {
+cache_rpm_dump () {
+   rpm_dump_cache=`
        case "$RPMBUILD" in
        rpm )
-               rpm -bp --define 'prep %dump' $BCOND $SPECFILE 2>&1 
+               rpm -bp --nodeps --define 'prep %dump' $BCOND $SPECFILE 2>&1 
                ;;
        rpmbuild )
-               rpmbuild --define 'prep %dump' $BCOND $SPECFILE 2>&1 
+               rpmbuild --nodigest --nosignature --define 'prep %dump' $BCOND $SPECFILE 2>&1 
                ;;
-       esac
-}
-
-parse_spec()
-{
-    if [ -n "$DEBUG" ]; then
-       set -x;
-       set -v;
-    fi
-
-    cd $SPECS_DIR
-    if [ "$NOSRCS" != "yes" ]; then
-       SOURCES="`rpm_dump | awk '/SOURCEURL[0-9]+/ {print $3}'`"
-    fi
-    if (rpm_dump | grep -qEi ":.*nosource.*1"); then
-       FAIL_IF_NO_SOURCES="no"
-    fi
-
-    PATCHES="`rpm_dump | awk '/PATCHURL[0-9]+/ {print $3}'`"
-    ICONS="`awk '/^Icon:/ {print $2}' ${SPECFILE}`"
-    PACKAGE_NAME="`$RPM -q --qf '%{NAME}\n' --specfile ${SPECFILE} 2> /dev/null | head -1`"
-    PACKAGE_VERSION="`$RPM -q --qf '%{VERSION}\n' --specfile ${SPECFILE} 2> /dev/null| head -1`"
-    PACKAGE_RELEASE="`$RPM -q --qf '%{RELEASE}\n' --specfile ${SPECFILE} 2> /dev/null | head -1`"
-
-    if [ -n "$BE_VERBOSE" ]; then
-       echo "- Sources :  `nourl $SOURCES`"
-       if [ -n "$PATCHES" ]; then
-           echo "- Patches :  `nourl $PATCHES`"
-       else
-           echo "- Patches :  *no patches needed*"
-       fi
-       if [ -n "$ICONS" ]; then
-           echo "- Icon    :  `nourl $ICONS`"
-       else
-           echo "- Icon    :  *no package icon*"
-       fi
-       echo "- Name    : $PACKAGE_NAME"
-       echo "- Version : $PACKAGE_VERSION"
-       echo "- Release : $PACKAGE_RELEASE"
-    fi
+       esac`
 }
 
-Exit_error()
-{
-    if [ -n "$DEBUG" ]; then
-       set -x;
-       set -v;
-    fi
-
-    cd $__PWD
-
-    case "$1" in
-    "err_no_spec_in_cmdl" )
-       echo "ERROR: spec file name not specified.";
-       exit 2 ;;
-    "err_no_spec_in_repo" )
-       echo "Error: spec file not stored in CVS repo.";
-       exit 3 ;;
-    "err_no_source_in_repo" )
-       echo "Error: some source, patch or icon files not stored in CVS repo. ($2)";
-       exit 4 ;;
-    "err_build_fail" )
-       echo "Error: package build failed. (${2:-no more info})";
-       exit 5 ;;
-    esac
-}
-
-init_builder()
-{
-    if [ -n "$DEBUG" ]; then
-       set -x;
-       set -v;
+rpm_dump () {
+    if [ -z "$rpm_dump_cache" ] ; then
+       echo "internal error: cache_rpm_dump not called!" 1>&2
     fi
-
-    SOURCE_DIR="`$RPM --eval '%{_sourcedir}'`"
-    SPECS_DIR="`$RPM --eval '%{_specdir}'`"
-
-    __PWD=`pwd`
+    echo "$rpm_dump_cache"
 }
 
-get_spec()
+parse_spec()
 {
     if [ -n "$DEBUG" ]; then
        set -x;
        set -v;
     fi
 
-    if [ "$NOCVSSPEC" != "yes" ]; then
-       cd $SPECS_DIR
-
-       OPTIONS="up "
-
-       if [ -n "$CVSROOT" ]; then
-           OPTIONS="-d $CVSROOT $OPTIONS"
-       else
-           if [ ! -s CVS/Root -a "$NOCVSSPEC" != "yes" ]; then
-               echo "warning: No cvs access defined - using local .spec file"
-               NOCVSSPEC="yes"
-           fi
-       fi
-
-       if [ -z "$CVSDATE" -a -z "$CVSTAG" ]; then
-           OPTIONS="$OPTIONS -A"
-       else
-           if [ -n "$CVSDATE" ]; then
-               OPTIONS="$OPTIONS -D $CVSDATE"
-           fi
-           if [ -n "$CVSTAG" ]; then
-               OPTIONS="$OPTIONS -r $CVSTAG"
-           fi
-       fi
-
-       result=1
-       retries_counter=0
-       while [ "$result" != "0" -a "$retries_counter" -le "$CVS_RETRIES" ]; do
-           retries_counter=$(( $retries_counter + 1 ))
-           output=$(LC_ALL=C cvs $OPTIONS $SPECFILE 2>&1)
-           result=$?
-           [ -n "$output" ] && echo "$output"
-           if [ "$result" -ne "0" ]; then
-               if (echo "$output" | grep -qE "(Cannot connect to|connect to .* failed|Connection reset by peer|Connection timed out)") && [ "$retries_counter" -le "$CVS_RETRIES" ]; then
-                   echo "Trying again [$SPECFILE]... ($retries_counter)"
-                   sleep 2
-                   continue
-               fi
-               Exit_error err_no_spec_in_repo;
-           fi
-       done
-    fi
-    if [ ! -f "$SPECFILE" ]; then
-       Exit_error err_no_spec_in_repo;
-    fi
-
-    if [ "$CHMOD" = "yes" -a -n "$SPECFILE" ]; then
-       chmod $CHMOD_MODE $SPECFILE
-    fi
-    unset OPTIONS
-    grep -E -m 1 "^#.*Revision:.*Date" $SPECFILE
-}
-
-find_mirror(){
-
-    cd "$SPECS_DIR"
-    url="$1"
-    if [ ! -f "mirrors" -a "$NOCVSSPEC" != "yes" ] ; then
-       cvs update mirrors >&2
-    fi
-
-    IFS="|"
-    while read origin mirror name rest; do
-       ol=`echo -n "$origin"|wc -c`
-       prefix="`echo -n "$url" | head -c $ol`"
-       if [ "$prefix" = "$origin" ] ; then
-           suffix="`echo "$url"|cut -b $ol-`"
-           echo -n "$mirror$suffix"
-           return 0
-       fi
-    done < mirrors
-    echo "$url"
-}
-
-src_no ()
-{
-    cd $SPECS_DIR
-    rpm_dump | \
-       grep "SOURCEURL[0-9]*[  ]*$1""[         ]*$" | \
-       sed -e 's/.*SOURCEURL\([0-9][0-9]*\).*/\1/' | \
-       head -1 | xargs
-}
-
-src_md5 ()
-{
-    no=$(src_no "$1")
-    [ -z "$no" ] && return
     cd $SPECS_DIR
-    spec_rev=$(grep $SPECFILE CVS/Entries | sed -e s:/$SPECFILE/:: -e s:/.*::)
-    if [ -z "$spec_rev" ]; then
-       spec_rev="$(head -1 $SPECFILE | sed -e 's/.*\$Revision: \([0-9.]*\).*/\1/')"
-    fi
-    spec="$SPECFILE[0-9.,]*,$(echo $spec_rev | sed 's/\./\\./g')"
-    md5=$(grep -s -v '^#' additional-md5sums | \
-       grep -E "[      ]$(basename "$1")[      ]+${spec}([     ,]|\$)" | \
-       sed -e 's/^\([0-9a-f]\{32\}\).*/\1/' | \
-       grep -E '^[0-9a-f]{32}$')
-    if [ X"$md5" = X"" ] ; then
-       grep -i "#[     ]*Source$no-md5[        ]*:" $SPECFILE | sed -e 's/.*://' | xargs
-    else
-       if [ $(echo "$md5" | wc -l) != 1 ] ; then
-           echo "$SPECFILE: more then one entry in additional-md5sums for $1" 1>&2
-       fi
-       echo "$md5" | tail -1
-    fi
-}
 
-distfiles_url ()
-{
-    echo "$PROTOCOL$DISTFILES_SERVER/by-md5/$(src_md5 "$1" | sed -e 's|^\(.\)\(.\)|\1/\2/&|')/$(basename "$1")"
-}
+    cache_rpm_dump
 
-good_md5 ()
-{
-    md5=$(src_md5 "$1")
-    [ "$md5" = "" ] || \
-    [ "$md5" = "$(md5sum $(nourl "$1") 2> /dev/null | sed -e 's/ .*//')" ]
-}
-
-get_files()
-{
-    GET_FILES="$@"
-
-    if [ -n "$DEBUG" ]; then
-       set -x;
-       set -v;
-    fi
-
-    if [ -n "$1$2$3$4$5$6$7$8$9${10}" ]; then
-       cd $SOURCE_DIR
-
-       OPTIONS="up "
-       if [ -n "$CVSROOT" ]; then
-           OPTIONS="-d $CVSROOT $OPTIONS"
-       else
-           if [ ! -s CVS/Root -a "$NOCVS" != "yes" ]; then
-               echo "warning: No cvs access defined for SOURCES"
-               NOCVS="yes"
-           fi
-       fi
-       if [ -z "$CVSDATE" -a -z "$CVSTAG" ]; then
-           OPTIONS="$OPTIONS -A"
-       else
-           if [ -n "$CVSDATE" ]; then
-               OPTIONS="$OPTIONS -D $CVSDATE"
-           fi
-           if [ -n "$CVSTAG" ]; then
-               OPTIONS="$OPTIONS -r $CVSTAG"
-           fi
-       fi
-       for i in $GET_FILES; do
-           FROM_DISTFILES=0
-           if [ ! -f `nourl $i` ] || [ $ALWAYS_CVSUP = "yes" ]; then
-               if echo $i | grep -vE '(http|ftp|https|cvs|svn)://' | grep -qE '\.(gz|bz2)$']; then
-                   echo "Warning: no URL given for $i"
-               fi
-
-               if [ -n "$(src_md5 "$i")" ] && [ -z "$NODIST" ]; then
-                   if good_md5 "$i"; then
-                       echo "$(nourl "$i") having proper md5sum already exists"
-                       continue
-                   fi
-                   target=$(nourl "$i")
-                   url=$(distfiles_url "$i")
-                   if [ `echo $url | grep -E '^(\.|/)'` ]; then
-                       ${GETLOCAL} $url $target
-                   else
-                       FROM_DISTFILES=1
-                       if [ -z "$NOMIRRORS" ]; then
-                           url="`find_mirror "$url"`"
-                       fi
-                       ${GETURI} -O "$target" "$url" || \
-                           if [ `echo $url | grep -E 'ftp://'` ]; then
-                               ${GETURI2} -O "$target" "$url"
-                           fi
-                       test -s "$target" || rm -f "$target"
-                   fi
-               elif [ -z "$(src_md5 "$i")" ] && \
-                    ( [ -z "$NOCVS" ] || echo $i | grep -qvE '(ftp|http|https)://' ); then
-                   result=1
-                   retries_counter=0
-                   while [ "$result" != "0" -a "$retries_counter" -le "$CVS_RETRIES" ]; do
-                       retries_counter=$(( $retries_counter + 1 ))
-                       output=$(LC_ALL=C cvs $OPTIONS `nourl $i` 2>&1)
-                       result=$?
-                       [ -n "$output" ] && echo "$output"
-                       if (echo "$output" | grep -qE "(Cannot connect to|connect to .* failed|Connection reset by peer|Connection timed out)") && [ "$result" -ne "0" -a "$retries_counter" -le "$CVS_RETRIES" ]; then
-                               echo "Trying again [`nourl $i`]... ($retries_counter)"
-                               sleep 2
-                               continue
-                       else
-                               break
-                       fi
-                   done
-               fi
-
-               if [ -z "$NOURLS" ] && [ ! -f "`nourl $i`" -o -n "$UPDATE" ] && [ `echo $i | grep -E 'ftp://|http://|https://'` ]; then
-                   if [ -z "$NOMIRRORS" ]; then
-                       im="`find_mirror "$i"`"
-                   else
-                       im="$i"
-                   fi
-                   ${GETURI} "$im" || \
-                       if [ `echo $im | grep -E 'ftp://'` ]; then ${GETURI2} "$im" ; fi
-               fi
-
-           fi
-           srcno=$(src_no $i)
-           if [ ! -f "`nourl $i`" -a "$FAIL_IF_NO_SOURCES" != "no" ]; then
-               Exit_error err_no_source_in_repo $i;
-           elif [ -n "$UPDATE5" ] && \
-               ( ( [ -n "$ADD5" ] && echo $i | grep -q -E 'ftp://|http://|https://' && \
-                   [ -z "$(grep -E -i '^NoSource[      ]*:[    ]*'$i'([        ]|$)' $SPECS_DIR/$SPECFILE)" ] ) || \
-               grep -q -i -E '^#[      ]*source'$(src_no $i)'-md5[     ]*:' $SPECS_DIR/$SPECFILE )
-           then
-               echo "Updating source-$srcno md5."
-               md5=$(md5sum `nourl $i` | cut -f1 -d' ')
-               perl -i -ne '
-                               print unless /^\s*#\s*Source'$srcno'-md5\s*:/i;
-                               print "# Source'$srcno'-md5:\t'$md5'\n" 
-                                       if /^Source'$srcno'\s*:\s+/;
-                               ' \
-                               $SPECS_DIR/$SPECFILE
-           fi
-
-           if good_md5 "$i"; then
-               :
-           elif [ "$FROM_DISTFILES" = 1 ]; then
-               # wrong md5 from distfiles: remove the file and try again
-               # but only once ...
-               FROM_DISTFILES=2
-               rm -f $target
-               ${GETURI} -O "$target" "$url" || \
-                   if [ `echo $url | grep -E 'ftp://'` ]; then
-                       ${GETURI2} -O "$target" "$url"
-                   fi
-               test -s "$target" || rm -f "$target"
-           fi
-
-           if good_md5 "$i"; then
-               :
-
-VERSION="\
-Build package utility from PLD CVS repository
-V 0.11 (C) 1999-2003 Free Penguins".
-PATH="/bin:/usr/bin:/usr/sbin:/sbin:/usr/X11R6/bin"
-
-COMMAND="build"
-
-SPECFILE=""
-BE_VERBOSE=""
-QUIET=""
-CLEAN=""
-DEBUG=""
-NOURLS=""
-NOCVS=""
-NOCVSSPEC=""
-NODIST=""
-UPDATE=""
-UPDATE5=""
-ADD5=""
-ALWAYS_CVSUP=${ALWAYS_CVSUP:-"yes"}
-if [ -s CVS/Root ]; then
-    CVSROOT=$(cat CVS/Root)
-else
-    CVSROOT=${CVSROOT:-""}
-fi
-# Example: LOGFILE='../log.$PACKAGE_NAME'
-# Yes, you can use variable name! Note _single_ quotes!
-LOGFILE=''
-
-LOGDIR=""
-LOGDIROK=""
-LOGDIRFAIL=""
-LASTLOG_FILE=""
-LTAG=""
-CHMOD="no"
-CHMOD_MODE="0444"
-RPMOPTS=""
-BCOND=""
-
-PATCHES=""
-SOURCES=""
-ICONS=""
-PACKAGE_RELEASE=""
-PACKAGE_VERSION=""
-PACKAGE_NAME=""
-PROTOCOL="ftp"
-WGET_RETRIES=${MAX_WGET_RETRIES:-0}
-CVS_RETRIES=${MAX_CVS_RETRIES:-1000}
-
-CVSTAG=""
-RES_FILE=""
-
-CVS_SERVER="cvs.pld-linux.org"
-DISTFILES_SERVER="://distfiles.pld-linux.org"
-
-DEF_NICE_LEVEL=0
-
-FAIL_IF_NO_SOURCES="yes"
-
-GETURI="wget --passive-ftp -c -nd -t$WGET_RETRIES --inet"
-GETURI2="wget -c -nd -t$WGET_RETRIES --inet"
-GETLOCAL="cp -a"
-
-if (rpm --version 2>&1 | grep -q '4.0.[0-2]'); then
-    RPM="rpm"
-    RPMBUILD="rpm"
-else
-    RPM="rpm"
-    RPMBUILD="rpmbuild"
-fi
-
-if [ -f ~/etc/builderrc ]; then
-    . ~/etc/builderrc
-elif [ -f ~/.builderrc ]; then
-    . ~/.builderrc
-fi
-
-#---------------------------------------------
-# functions
-
-usage()
-{
-    if [ -n "$DEBUG" ]; then set -xv; fi
-    echo "\
-Usage: builder [-D|--debug] [-V|--version] [-a|--as_anon] [-b|-ba|--build]
-
-       [-bb|--build-binary] [-bs|--build-source] [-u|--try-upgrade]
-       [{-B|--branch} <branch>] [{-d|--cvsroot} <cvsroot>] [-g|--get]
-       [-h|--help] [--http] [{-l,--logtofile} <logfile>] [-m|--mr-proper]
-       [-q|--quiet] [--date <yyyy-mm-dd> [-r <cvstag>] [{-T--tag <cvstag>]
-       [-Tvs|--tag-version-stable] [-Tvn|--tag-version-nest]
-       [-Ts|--tag-stable] [-Tn|--tag-nest] [-Tv|--tag-version]
-       [-nu|--no-urls] [-v|--verbose] [--opts <rpm opts>]
-       [--with/--without <feature>] [--define <macro> <value>] <package>[.spec]
-
-       -5, --update-md5
-                       - update md5 comments in spec, implies -nd
-       -a5, --add-md5  - add md5 comments to URL sources, implies -nc -nd
-       -D, --debug     - enable script debugging mode,
-       -V, --version   - output builder version
-       -a, --as_anon   - get files via pserver as cvs@$CVS_SERVER,
-       -b, -ba,
-       --build         - get all files from CVS repo or HTTP/FTP and build
-                         package from <package>.spec,
-       -bb, --build-binary
-                       - get all files from CVS repo or HTTP/FTP and build
-                         binary only package from <package>.spec,
-       -bs,
-       --build-source  - get all files from CVS repo or HTTP/FTP and only
-                         pack them into src.rpm,
-       -B, --branch    - add branch
-       -c, --clean     - clean all temporarily created files (in BUILD,
-                         SOURCES, SPECS and \$RPM_BUILD_ROOT),
-       -d <cvsroot>, --cvsroot <cvsroot>
-                       - setup \$CVSROOT,
-       --define <macro> <value>
-                       - define a macro <macro> with value <value>,
-       -g, --get       - get <package>.spec and all related files from
-                         CVS repo or HTTP/FTP,
-       -h, --help      - this message,
-       --http          - use http instead of ftp,
-       -l <logfile>, --logtofile <logfile>
-                       - log all to file,
-       -m, --mr-proper - only remove all files related to spec file and
-                         all work resources,
-       -nc, --no-cvs   - don't download sources from CVS, if source URL is
-                         given,
-       -ncs, --no-cvs-specs
-                       - don't check specs in CVS
-       -nd, --no-distfiles
-                       - don't download from distfiles
-       -nm, --no-mirrors - don't download from mirror, if source URL is given,
-       -nu, --no-urls  - don't try to download from FTP/HTTP location,
-       -ns, --no-srcs  - don't download Sources
-       -ns0, --no-source0
-                       - don't download Source0
-       --opts <rpm opts>
-                       - additional options for rpm
-       -q, --quiet     - be quiet,
-       --date yyyy-mm-dd
-                       - build package using resources from specified CVS
-                         date,
-       -r <cvstag>, --cvstag <cvstag>
-                       - build package using resources from specified CVS
-                         tag,
-       -T <cvstag> , --tag <cvstag>
-                       - add cvs tag <cvstag> for files,
-       -Tvs, --tag-version-stable
-                       - add cvs tags STABLE and NAME-VERSION-RELESE for files,
-       -Tvn, --tag-version-nest
-                       - add cvs tags NEST and NAME-VERSION-RELESE for files,
-       -Ts, --tag-stable
-                       - add cvs tag STABLE for files,
-       -Tn, --tag-nest
-                       - add cvs tag NEST for files,
-       -Tv, --tag-version
-                       - add cvs tag NAME-VERSION-RELESE for files,
-       -v, --verbose   - be verbose,
-       -u, --try-upgrade
-                       - check version, and try to upgrade package
-       -un, --try-upgrade-with-float-version
-                       - as above, but allow float version
-       -U, --update
-                       - refetch sources, don't use distfiles, and update md5 
-                         comments
-       --with/--without <feature>
-                       - conditional build package depending on
-                         %_with_<feature>/%_without_<feature> macro
-                         switch
-"
-}
-
-rpm_dump () {
-       case "$RPMBUILD" in
-       rpm )
-               rpm -bp --define 'prep %dump' $BCOND $SPECFILE 2>&1 
-               ;;
-       rpmbuild )
-               rpmbuild --define 'prep %dump' $BCOND $SPECFILE 2>&1 
-               ;;
-       esac
-}
-
-parse_spec()
-{
-    if [ -n "$DEBUG" ]; then
-       set -x;
-       set -v;
-    fi
-
-    cd $SPECS_DIR
     if [ "$NOSRCS" != "yes" ]; then
        SOURCES="`rpm_dump | awk '/SOURCEURL[0-9]+/ {print $3}'`"
     fi
@@ -826,7 +336,7 @@ get_spec()
            result=$?
            [ -n "$output" ] && echo "$output"
            if [ "$result" -ne "0" ]; then
-               if (echo "$output" | grep -qE "(Cannot connect to|connect to .* failed|Connection reset by peer|Connection timed out)") && [ "$retries_counter" -le "$CVS_RETRIES" ]; then
+               if (echo "$output" | grep -qE "(Cannot connect to|connect to .* failed|Connection reset by peer|Connection timed out|Unknown host)") && [ "$retries_counter" -le "$CVS_RETRIES" ]; then
                    echo "Trying again [$SPECFILE]... ($retries_counter)"
                    sleep 2
                    continue
@@ -944,6 +454,14 @@ get_files()
            fi
        fi
        for i in $GET_FILES; do
+           if [ -n "$UPDATE5" ]; then
+               if [ -n "$ADD5" ]; then
+                   [ `nourl $i` = "$i" ] && continue
+                   grep -qiE '^#[      ]*Source'$(src_no $i)'-md5[     ]*:' $SPECS_DIR/$SPECFILE && continue
+               else
+                   grep -qiE '^#[      ]*Source'$(src_no $i)'-md5[     ]*:' $SPECS_DIR/$SPECFILE || continue
+               fi
+           fi
            FROM_DISTFILES=0
            if [ ! -f `nourl $i` ] || [ $ALWAYS_CVSUP = "yes" ]; then
                if echo $i | grep -vE '(http|ftp|https|cvs|svn)://' | grep -qE '\.(gz|bz2)$']; then
@@ -968,10 +486,13 @@ get_files()
                            if [ `echo $url | grep -E 'ftp://'` ]; then
                                ${GETURI2} -O "$target" "$url"
                            fi
-                       test -s "$target" || rm -f "$target"
+                       if ! test -s "$target"; then
+                           rm -f "$target"
+                           FROM_DISTFILES=0
+                       fi
                    fi
-               elif [ -z "$(src_md5 "$i")" ] && \
-                    ( [ -z "$NOCVS" ] || echo $i | grep -qvE '(ftp|http|https)://' ); then
+               elif [ -z "$(src_md5 "$i")" -a "$NOCVS" != "yes" ]; then
+                   # ( echo $i | grep -qvE '(ftp|http|https)://' ); -- if CVS should be used, but URLs preferred
                    result=1
                    retries_counter=0
                    while [ "$result" != "0" -a "$retries_counter" -le "$CVS_RETRIES" ]; do
@@ -979,7 +500,7 @@ get_files()
                        output=$(LC_ALL=C cvs $OPTIONS `nourl $i` 2>&1)
                        result=$?
                        [ -n "$output" ] && echo "$output"
-                       if (echo "$output" | grep -qE "(Cannot connect to|connect to .* failed|Connection reset by peer|Connection timed out)") && [ "$result" -ne "0" -a "$retries_counter" -le "$CVS_RETRIES" ]; then
+                       if (echo "$output" | grep -qE "(Cannot connect to|connect to .* failed|Connection reset by peer|Connection timed out|Unknown host)") && [ "$result" -ne "0" -a "$retries_counter" -le "$CVS_RETRIES" ]; then
                                echo "Trying again [`nourl $i`]... ($retries_counter)"
                                sleep 2
                                continue
@@ -999,6 +520,7 @@ get_files()
                        if [ `echo $im | grep -E 'ftp://'` ]; then ${GETURI2} "$im" ; fi
                fi
 
+
            fi
            srcno=$(src_no $i)
            if [ ! -f "`nourl $i`" -a "$FAIL_IF_NO_SOURCES" != "no" ]; then
@@ -1023,6 +545,7 @@ get_files()
            elif [ "$FROM_DISTFILES" = 1 ]; then
                # wrong md5 from distfiles: remove the file and try again
                # but only once ...
+               echo "MD5 sum mismatch. Trying full fetch."
                FROM_DISTFILES=2
                rm -f $target
                ${GETURI} -O "$target" "$url" || \
@@ -1063,7 +586,14 @@ tag_files()
     if [ -n "$1$2$3$4$5$6$7$8$9${10}" ]; then
        echo "Version: $PACKAGE_VERSION"
        echo "Release: $PACKAGE_RELEASE"
-       TAGVER=$PACKAGE_NAME-`echo $PACKAGE_VERSION | sed -e "s/\./\_/g" -e "s/@/#/g"`-`echo $PACKAGE_RELEASE | sed -e "s/\./\_/g" -e "s/@/#/g"`
+       # Check whether first character of PACKAGE_NAME is legal for tag name
+       if [ -z "${PACKAGE_NAME##[_0-9]*}" -a -z "$TAG_PREFIX" ]; then
+           TAG_PREFIX=tag_
+       fi
+       TAGVER=$TAG_PREFIX$PACKAGE_NAME-`echo $PACKAGE_VERSION | sed -e "s/\./\_/g" -e "s/@/#/g"`-`echo $PACKAGE_RELEASE | sed -e "s/\./\_/g" -e "s/@/#/g"`
+       # Remove #kernel.version_release from TAGVER because tagging sources
+       # could occur with different kernel-headers than kernel-headers used at build time.
+       TAGVER=$(echo "$TAGVER" | sed -e 's/#.*//g')
        if [ "$TAG_VERSION" = "yes" ]; then
            echo "CVS tag: $TAGVER"
        fi
@@ -1078,7 +608,9 @@ tag_files()
 
        cd $SOURCE_DIR
        for i in $TAG_FILES; do
-           if [ -f `nourl $i` ]; then
+           # don't tag non cvs files (ie. stored on distfiles)
+           [ "`nourl $i`" != "$i" ] && continue
+           if [ -f "`nourl $i`" ]; then
                if [ "$TAG_VERSION" = "yes" ]; then
                    cvs $OPTIONS $TAGVER `nourl $i`
                fi
@@ -1149,7 +681,7 @@ build_package()
 
     if [ -n "$TRY_UPGRADE" ]; then
 
-       if [ -n "FLOAT_VERSION" ]; then
+       if [ -n "$FLOAT_VERSION" ]; then
            TNOTIFY=`./pldnotify.awk $SPECFILE -n`
        else
            TNOTIFY=`./pldnotify.awk $SPECFILE`
@@ -1191,17 +723,12 @@ build_package()
            BUILD_SWITCH="-bs --nodeps" ;;
     esac
     if [ -n "$LOGFILE" ]; then
-       if [ -n "$CVSTAG" ]; then
-           LTAG="r_`echo $CVSTAG|sed -e 's/\./_/g'`_"
-       else
-           LTAG=""
-       fi
        LOG=`eval echo $LOGFILE`
        if [ -n "$LASTLOG_FILE" ]; then
            echo "LASTLOG=$LOG" > $LASTLOG_FILE
        fi
        RES_FILE=~/tmp/$RPMBUILD-exit-status.$RANDOM
-       (nice -n ${DEF_NICE_LEVEL} time $RPMBUILD $BUILD_SWITCH -v $QUIET $CLEAN $RPMOPTS $BCOND $SPECFILE; echo $? > $RES_FILE) 2>&1 |tee $LOG
+       (time nice -n ${DEF_NICE_LEVEL} $RPMBUILD $BUILD_SWITCH -v $QUIET $CLEAN $RPMOPTS $BCOND $SPECFILE; echo $? > $RES_FILE) 2>&1 |tee $LOG
        RETVAL=`cat $RES_FILE`
        rm $RES_FILE
        if [ -n "$LOGDIROK" ] && [ -n "$LOGDIRFAIL" ]; then
@@ -1233,6 +760,7 @@ nourl()
 {
     echo "$@" | sed 's#\<\(ftp\|http\|https\|cvs\|svn\)://[^ ]*/##g'
 }
+
 #---------------------------------------------
 # main()
 
@@ -1246,12 +774,14 @@ while test $# -gt 0 ; do
        -5 | --update-md5 )
            COMMAND="get";
            NODIST="yes"
+           NOCVSSPEC="yes"
            UPDATE5="yes"
            shift ;;
        -a5 | --add-md5 )
            COMMAND="get";
            NODIST="yes"
            NOCVS="yes"
+           NOCVSSPEC="yes"
            UPDATE5="yes"
            ADD5="yes"
            shift ;;
@@ -1334,6 +864,9 @@ while test $# -gt 0 ; do
            TAG=""
            TAG_VERSION="yes"
            shift;;
+       -Tp | --tag-prefix )
+           TAG_PREFIX="$2"
+           shift 2;;
        -T | --tag )
            COMMAND="tag";
            shift
@@ -1341,10 +874,11 @@ while test $# -gt 0 ; do
            TAG_VERSION="no"
            shift;;
        -U | --update )
+           COMMAND="get"
            UPDATE="yes"
+           NOCVSSPEC="yes"
            NODIST="yes"
            UPDATE5="yes"
-           COMMAND="get"
            shift ;;
        -u | --try-upgrade )
            TRY_UPGRADE="1"; shift ;;
@@ -1359,6 +893,10 @@ while test $# -gt 0 ; do
            shift 2
            RPMOPTS="${RPMOPTS} --define \"${MACRO} ${VALUE}\""
            ;;
+       --nodeps)
+           shift
+           RPMOPTS="${RPMOPTS} --nodeps"
+           ;;
        * )
            SPECFILE="`basename ${1} .spec`.spec"; shift ;;
     esac
@@ -1440,6 +978,13 @@ case "$COMMAND" in
                get_files $ICONS
                parse_spec;
            fi
+           # don't fetch sources from remote locations
+           new_SOURCES=""
+           for file in $SOURCES; do
+               [ "`nourl $file`" != "$file" ] && continue
+               new_SOURCES="$new_SOURCES $file"
+           done
+           SOURCES="$new_SOURCES"
            get_files $SOURCES $PATCHES;
            tag_files "$SOURCES $PATCHES $ICONS";
        else
This page took 0.076222 seconds and 4 git commands to generate.